'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loaderCreator = undefined;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _reactTemplates = require('react-templates/src/reactTemplates');

var _reactTemplates2 = _interopRequireDefault(_reactTemplates);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var babel = require('babel-core');
var orig = require.extensions['.js'];

var loaderCreator = exports.loaderCreator = function loaderCreator(opts) {
  return function (module, filename) {
    if (filename.indexOf('node_modules') >= 0) return orig(module, filename);

    var content = _fs2.default.readFileSync(filename, 'utf-8');
    var template = _reactTemplates2.default.convertTemplateToReact(content, opts);
    var code = babel.transform(template, {
      presets: ['es2015'],
      ast: false
    }).code;

    return module._compile(code, filename);
  };
};

exports.default = function (opts) {
  var loader = loaderCreator(opts);
  ['.rt'].forEach(function (ext) {
    require.extensions[ext] = loader;
  });
};